/* budgetPanel.c 
 *
 *  defines the GUIFront characteristics of the budget panel 
 */
  
#include <stdio.h>  
#include <intuition/gadgetclass.h>
#include <exec/memory.h>
#include <clib/exec_protos.h>
#include <clib/asl_protos.h>
#include <libraries/asl.h>

#include "amiCheck.h"
#include "dataBase.h"
#include "budgetPanel.h"
#include <string.h>


/* prototypes */
BOOL BudgetHandleGadget(struct IntuiMessage *);
BOOL BudgetInit(void);

static BOOL newbudget;
static struct Window *budgetWin;
static struct List budgetList;
static struct List *cats;
ExtErrorData BudgetExtData;
GUIFront *budgetGUI;

/* quick configure of some gadgets */

/* define gadgetspec */
GadgetSpec BPgadgetspecs[] = 
{
	{LISTVIEW_KIND,25,6, {0,0,0,0,NULL,NULL,GID_BPCATSRC,
		PLACETEXT_ABOVE},ListView,GS_DefaultTags},

	{LISTVIEW_KIND,25,6, {0,0,0,0,NULL,NULL,GID_BPCATSEL,
		PLACETEXT_ABOVE},ListView,GS_DefaultTags},

	{TEXT_KIND,0,0, {0,0,0,0,"% Budgeted",NULL,GID_BPPERCENT,
		PLACETEXT_LEFT},TxtZero,GS_DefaultTags},

	{TEXT_KIND,0,0, {0,0,0,0,"Remaining",NULL,GID_BPREMAIN,
		PLACETEXT_LEFT},TxtZero,GS_DefaultTags},

	{STRING_KIND,AMNTSIZE,0, {0,0,0,0,"_Amount",NULL,GID_BPAMOUNT,
		PLACETEXT_LEFT},strAmntTags,GS_DefaultTags | GS_NoWidthExtend},

	{SLIDER_KIND,0,0, {0,0,0,0,NULL,NULL,GID_BPADJUST,
		PLACETEXT_LEFT},NULL,GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Remove", NULL, GID_BPREMOVE,        
                PLACETEXT_IN}, NULL, GS_DefaultTags | GS_NoWidthExtend},

        {BUTTON_KIND,0,0,{0,0,0,0,"_OK", NULL, GID_BPOK,        
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Cancel", NULL, GID_BPCANCEL,        
                PLACETEXT_IN}, NULL, GS_DefaultTags},
};

/* set up array of pointers to our specs */
GadgetSpec *BP_BudgetSpecs[] =
{
        &BPgadgetspecs[0],
        &BPgadgetspecs[1],
        &BPgadgetspecs[2],
        &BPgadgetspecs[3],
        &BPgadgetspecs[4],
        &BPgadgetspecs[5],
        &BPgadgetspecs[6],
        &BPgadgetspecs[7],
	&BPgadgetspecs[8],
        NULL,
};

/* define the layout of this panel */
ULONG BP_BudgetPanel[] =
{
   GUIL_Flags, GUILF_PropShare | GUILF_EqualWidth,

   GUIL_HorizGroup, 1,
        GUIL_Flags, GUILF_PropShare,
	GUIL_FrameType, GUILFT_Recess,
        
	GUIL_VertGroup, 1,

		/* the overview stats */
		GUIL_HorizGroup,2,
			GUIL_GadgetSpecID, GID_BPPERCENT,
			GUIL_GadgetSpecID, GID_BPREMAIN,
		TAG_DONE,

		/* the two listviews */
		GUIL_HorizGroup,1,
			GUIL_HorizGroup,0,
				GUIL_FrameType, GUILFT_Ridge,
				GUIL_FrameHeadline, "Categories",

				GUIL_GadgetSpecID, GID_BPCATSRC,
			TAG_DONE,

			GUIL_HorizGroup,0,
				GUIL_FrameType, GUILFT_Ridge,
				GUIL_FrameHeadline, "Budgeted",

				GUIL_GadgetSpecID, GID_BPCATSEL,
			TAG_DONE,
		TAG_DONE,
			

		/* budget setting */
		GUIL_VertGroup,1,
			GUIL_FrameType, GUILFT_Ridge,
			GUIL_FrameHeadline, "Budget Control",

			GUIL_HorizGroup,0,	
				GUIL_GadgetSpecID, GID_BPAMOUNT,
				GUIL_GadgetSpecID, GID_BPADJUST,

               		TAG_DONE,

			GUIL_GadgetSpecID, GID_BPREMOVE,
		TAG_DONE,

	TAG_DONE,
        
    TAG_DONE,
    
    GUIL_HorizGroup,1,
        GUIL_Flags, GUILF_EqualSize | GUILF_EqualWidth,

           GUIL_GadgetSpecID, GID_BPOK,
           GUIL_GadgetSpecID, GID_BPCANCEL,
           
    TAG_DONE,   
           
TAG_DONE,
};


/****************************************************
* BudgetGUI ()
*
*	Creates the GUI for the budget panel.
*****************************************************/
void BudgetGUI(void)
{
 BOOL done = FALSE;
 BOOL noreply;
 UWORD ordinal;
 ULONG signal;
 
    
 AmiLock();
 
	GF_SetGUIAttr(budgetGUI, GUI_OpenGUI, TRUE, TAG_DONE);

 	/* grab window */
 	GF_GetGUIAttr(budgetGUI,GUI_Window,&budgetWin,TAG_DONE);

                /* Process input events */
                while (!done)
                {
                    struct IntuiMessage *imsg;

                    /* Wait for an event to occur */

                    signal = GF_Wait(guiapp,AmigaGuideSignal(agc));
		   if (signal & AmigaGuideSignal(agc)) {
			AmiHelpMsg();
			continue;
		    }


                    /* We only bother to listen for CLOSEWINDOW events.
                     * Of course, in a real application, you would be
                     * examining the Class field for IDCMP_GADGETUP
                     * messages and act accordingly.
                     */

                    while (imsg = GF_GetIMsg(guiapp))
                    {
			noreply = TRUE;
                        switch (imsg->Class) {
				case IDCMP_REFRESHWINDOW:
					RegRefresh(TRUE);
					break;

                                case IDCMP_CLOSEWINDOW:
					done = TRUE;
                                        break;

#if 0
				case IDCMP_GADGETUP:
					noreply = FALSE;
					done=BudgetHandleGadget(imsg);
					break;

				case IDCMP_RAWKEY:
					AmiHelpKey(imsg,GROUP_PANEL);
					break;
#endif
                        }
                                     
                              
                        if (noreply) GF_ReplyIMsg(imsg);
                    }
                }
   AmiUnlock();
  return;
}

/***************************************************
* BudgetHandleGadget()
*
*	Handles gadget events for this panel
****************************************************/
BOOL  BudgetHandleGadget(struct IntuiMessage *imsg)
{
 BOOL done = FALSE;
 struct Gadget *gad = (struct Gadget *)(imsg->IAddress);
 UWORD code = imsg->Code;
 categoryNode *temp;

 switch (gad->GadgetID) {
	
	case GID_BPOK:
		done = TRUE;
		/* copy stuff into new.. */
		newbudget = TRUE;
		break;

	case GID_BPCANCEL:
		done = TRUE;
		break;

 }

 GF_ReplyIMsg(imsg);
 return (done);
}

/****************************************************
* BudgetInit()
*
*	Set up some globals
*****************************************************/
BOOL BudgetInit(void)
{


 return (TRUE);
}
